unit Demo5Form1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Grids, DBGrids, DBCtrls, Db, SQLServer, StdCtrls,
  Mask;

type
  TForm1 = class(TForm)
    SQLServer1: TSQLServer;
    SQLQuery1: TSQLQuery;
    SQLQuery2: TSQLQuery;
    DataSource1: TDataSource;
    StatusBar1: TStatusBar;
    DataSource2: TDataSource;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    Splitter2: TSplitter;
    DBGrid2: TDBGrid;
    DBNavigator2: TDBNavigator;
    SQLQuery2title_id: TStringField;
    SQLQuery2title: TStringField;
    SQLQuery2type: TStringField;
    SQLQuery2pub_id: TStringField;
    SQLQuery2price: TCurrencyField;
    SQLQuery2advance: TCurrencyField;
    SQLQuery2royalty: TIntegerField;
    SQLQuery2ytd_sales: TIntegerField;
    SQLQuery2notes: TStringField;
    SQLQuery2pubdate: TDateTimeField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    DBMemo1: TDBMemo;
    SQLUpdate1: TSQLUpdate;
    SQLUpdate2: TSQLUpdate;
    procedure FormShow(Sender: TObject);
    procedure SQLQuery2BeforePost(DataSet: TDataSet);
    procedure SQLServer1Login(Database: TSQLServer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{  This demo show the use of TSQLQuery combined with TSQLUpdate
   in a master-detail application.

   Note the DeleteSQL on the SQLUpdate2-component. MS SQL Server
   allows you to send several sql-statements in one query which
   makes it easy to maintain master-detail relationsships without
   resorting to pascal-programming. }
   
procedure TForm1.FormShow(Sender: TObject);
begin
     with SQLServer1 do begin
          ServerName   :='THOMAS';
          DataBaseName := 'pubs';
          TrustedLogin := True;
     //     DBTrace(True); 
          try
             Open;
          except
             ShowMessage('Unable to login to server');
             abort;
          end;
     end;
     SQLQuery1.Open;   
     SQLQuery2.Open;
end;

procedure TForm1.SQLQuery2BeforePost(DataSet: TDataSet);
begin
     if Dataset.State = dsInsert then
        SQLUpdate2.Query[ukInsert].ParamByName('au_id').Value:=SQLQuery1.FieldbyName('au_id').Value;
end;

procedure TForm1.SQLServer1Login(Database: TSQLServer);
begin
     // Within this event you can show a custom login dialog
end;

end.
